var hxyxjs = {};
hxyxjs.os = {};
hxyxjs.os.isIOS = /iOS|iPhone|iPad|iPod/i.test(navigator.userAgent);
hxyxjs.os.isAndroid = !hxyxjs.os.isIOS;
hxyxjs.callbacks={}

hxyxjs.callback = function(callbackname, response) {
    var callbackobject = hxyxjs.callbacks[callbackname];
    console.log("xxx" + callbackname);
    if (callbackobject !== undefined) {
        if (callbackobject.callback !== undefined) {
            console.log("xxxxx" + response);
            var ret = callbackobject.callback(response);
            if (ret == false) {
                return;
            }
            delete hxyxjs.callbacks[callbackname];
        }
    }
}

hxyxjs.takeNativeAction = function(commandname, parameters) {
    console.log("hxyxjs takeNativeAction");
    var request = {}
    request.name = commandname;
    request.param = parameters;
    if (window.hxyxjs.os.isAndroid) {
        console.log("android take native action" + JSON.stringify(request));
        window.hxyxwebview.takeNativeAction(JSON.stringify(request));
    } else {
        window.webkit.messageHandlers.hxyxwebview.postMessage(JSON.stringify(request))
    }
}

hxyxjs.takeNativeActionWithCallback = function(commandname, parameters, callback) {
    var callbackname = "nativetojs_callback_" + (new Date()).getTime() + "_" + Math.floor(Math.random() * 10000);
    hxyxjs.callbacks[callbackname] = {callback:callback};

    var request = {};
    request.name = commandname;
    request.param = parameters;
    request.param.callbackname = callbackname;
    if (window.hxyxjs.os.isAndroid) {
            console.log("android take native action with call back: " + JSON.stringify(request));
            window.hxyxwebview.takeNativeAction(JSON.stringify(request));
        } else {
            window.webkit.messageHandlers.hxyxwebview.postMessage(JSON.stringify(request))
    }
}

window.hxyxjs = hxyxjs;